<template>
  <q-page class="bg-grey-3 column" >
    <div class="row q-pa-sm bg-primary">
      <!-- //class="col" amplia a toda en la columna -->
      <!-- //@keyup para que al presioanr enter grabe la tarea -->
      <q-input
        v-model="newTask"
        @keyup.enter="addTask"
        class="col"
        square
        filled
        bg-color="white"
        placeholder="Añadir Task"
        dense>
        <template v-slot:append>
          <q-btn
            @click="addTask"
            round
            dense
            flat
            icon="add" />
        </template>
      </q-input>
    </div>
    <!-- </q-page>class="flex flex-center"> -->
    <!-- <img
      alt="Quasar logo"
      src="~assets/quasar-logo-vertical.svg"
      style="width: 200px; height: 200px"
    > -->
    <q-list class="bg-white" separator bordered>
      <!--
        Rendering a <label> tag (notice tag="label")
        so QCheckboxes will respond to clicks on QItems to
        change Toggle state.
      -->
      <!-- //se aumento la propirdad clickable y @click para permitir hacer click
      //en todo el item no solo el chekbox -->
      <!-- //Se almacenara en una :class="done" el valor del check para trabajarlo -->
      <!-- --se pone :class porque es un valor dinamico, no fijo, eso significa los dos puntos -->
      <!-- y se pondra un color azul para agruparlo visualmente -->
      <q-item
        v-for="(task, index) in tasks"
        :key="task.title"
        @click="task.done =! task.done"
        :class="{'done bg-blue-1': task.done }"
        clickable
        v-ripple>
        <q-item-section avatar>
          <!-- // class="no-pointer-events" para anular los click en el q-checkbox
          //se habilito el click en todo el item no solo en la casilla de check -->
          <q-checkbox
            v-model="task.done"
            class="no-pointer-events"
            color="primary" />
        </q-item-section>
        <q-item-section>
          <q-item-label>{{ task.title }}</q-item-label>
        </q-item-section>
        <!-- //añadir x -->
        <q-item-section
          v-if="task.done"
          side


        >
        <!-- @click.stop="deleteTask(index)" -->
          <q-btn
            @click.stop="deleteTask(index)"
            flat
            round
            dense
            color="primary"
            icon="delete" />
        </q-item-section>
      </q-item>
    </q-list>
    <div
      v-if="!tasks.length"
      class="no-tasks absolute-center">
      <q-icon
        name="check"
        size="100px"
        color="primary"

      />
      <div class="text-h5 text-primary text-center">
        No hay tareas
      </div>
    </div>
    <!-- Dialog alert -->
    <!-- <q-dialog v-model="confirm" persistent>
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar icon="signal_wifi_off" color="primary" text-color="white" />
          <span class="q-ml-sm">You are currently not connected to any network.</span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
          <q-btn flat label="Turn on Wifi" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog> -->

  </q-page>
</template>

<script>
//import { defineComponent } from 'vue'
//import { useQuasar } from 'quasar'

export default ({
  // name: 'IndexPage'
  // setup () {
  //   const $q = useQuasar()
  // },
  data() {
    return {
      newTask:'',
      tasks: [
        {
          title: 'POst 1',
          done: false,
        },
        {
          title: 'Post2',
          done: false,
        },{
          title: 'Post3',
          done: true,
        },
      ],
    }
  },
  methods: {
    //elimina un item de tasks en la posicion index
    deleteTask(index)
    {
      this.$q.dialog({
        title: 'Confirm',
        message: 'Esta seguro de elimar el item?'+this.tasks[index].name,
        cancel: true,
        persistent: true
      }).onOk(() => {
        // console.log('>>>> OK')
        this.tasks.splice(index,1);
        //trigger notification
        this.$q.notify('Tarea Eliminada');
      })
    },
    addTask(){
      console.log('task');
      this.tasks.push({
        title: this.newTask,
        done: false,
      });
      this.newTask=''
    }

  },
})
</script>

// --Colocar estilo a las tareas con true, completadas
<style lang="scss">
  .done {
    .q-item__label {
      text-decoration: line-through;
      color: #bbb;
    }
  }
  .no-tasks {
    opacity: 0.5;
  }
</style>
